try {
	isGadget = (System.Gadget !== undefined);
} catch(e) {
	isGadget = false;
}

function removeNL(s){ 
  return s.toString().replace(/[\0\n\r\t]/g,'');
}

function setFromGadget(tryFirst, otherwise) {
	if (isGadget) {
	tryFirst = (new Function('try {return '+tryFirst+';} catch(e){}'))();//reusing same var
		if (tryFirst.toString()!='') {
			return tryFirst;
		} else {
			return otherwise;
		}
	} else {
	return otherwise;
	}
}

function saveToGadget(key, value) {
	if (isGadget) {
		System.Gadget.Settings.write(key, value);
	}
}

functionRunOrder = new Array('setUpSignal','setUpIPinternal','setUpIPexternal','setUpCPU','setUpRAM','setUpDrives','setUpBattery','setUpUpdate');
totalCPU = setFromGadget('System.Machine.CPUs.count', 4);
totalRAM = setFromGadget('System.Machine.totalMemory', 2037);

gadgetName = 'iPK Combo';
gadgetShortName = 'ipkcombo';
gadgetVersion = parseFloat('1.3');

skinColor = '#007dd7';
skinFadeColor = '#00ccff';
suffixes = Array('MB','GB','TB');
IPvalidChars = '.0123456789';
xmlHttpObjects = ["Microsoft.XmlHttp", "MSXML2.XmlHttp", "MSXML2.XmlHttp.3.0", "MSXML2.XmlHttp.4.0", "MSXML2.XmlHttp.5.0", "Msxml2.XMLHTTP.6.0", "Msxml2.XMLHTTP.7.0"];
driveLetters = 'ABCDEFGHIJKLMNOPQRSTUVWXYZ';
exceptDrives = 'AB';//Defaut value
drivesData = new Array;
drivesTarget = new Array;

for(var i=0; i<driveLetters.length; i++) {
	//generate placeholders
	drivesData[driveLetters.charAt(i)] = [];
	drivesData[driveLetters.charAt(i)]['isReady'] = false;
	drivesData[driveLetters.charAt(i)]['totalSize'] = 1;
	drivesData[driveLetters.charAt(i)]['freeSpace'] = 1;
	drivesData[driveLetters.charAt(i)]['volumeLabel'] = '';
	drivesTarget[driveLetters.charAt(i)] = [];
	drivesTarget[driveLetters.charAt(i)]['isReady'] = false;
	drivesTarget[driveLetters.charAt(i)]['totalSize'] = 1;
	drivesTarget[driveLetters.charAt(i)]['freeSpace'] = 1;
	drivesTarget[driveLetters.charAt(i)]['volumeLabel'] = '';
}
delete i;



validateIPoctet = '(?:25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])';
validateIPipmatch = '(?:' + validateIPoctet + '\\.){3}' + validateIPoctet;
detectIPregExp = new RegExp(validateIPipmatch, 'm');
validateIPregExp = new RegExp( '^' + validateIPipmatch + '$' );

BGblank = 'url()';

defUpdateExIP = 600;
defAcceleration = 3;
defCustomColorNormal = '#ffff00';
defCustomColorFade   = '#0000ff';
defUrlToCheckIPprimary = 'http://pavel.kuzub.com/ip/';
defUrlToCheckIPsecondary = 'http://www.ipchicken.com/';
urlToCheckIP = '';
urlToCheckUpdate = 'http://pavel.kuzub.com/ip/update.php';

enable = new Array;
IntervalTimeouts = new Array;
TimeoutTimeouts = new Array;
LastExecTime = new Array;
LastExecTime['generateUpdateCPU'] = 0;
LastExecTime['generateUpdateRAM'] = 0;
LastExecTime['generateUpdateIPinternal'] = 0;
LastExecTime['generateUpdateIPexternal'] = 0;
LastExecTime['generateUpdateSignal'] = 0;
LastExecTime['generateUpdateBattery'] = 0;
LastExecTime['updateCPU'] = 0;
LastExecTime['updateRAM'] = 0;
LastExecTime['updateDrives'] = 0;
LastEndTime = new Array;
LastEndTime['updateCPU'] = 1;
LastEndTime['updateRAM'] = 1;
LastEndTime['updateDrives'] = 1;

Timer = new Array;
Timer['myCollectGarbage'] = 200;
Timer['GadgetReload'] = 1800000;
Timer['generateUpdateCPU'] = 2000;
Timer['generateUpdateRAM'] = 3000;
Timer['generateUpdateIPinternal'] = 5000;
Timer['generateUpdateIPexternal'] = 5000;
Timer['generateUpdateSignal'] = 2000;
Timer['animateSignalTrigger'] = 5000;
Timer['generateUpdateBattery'] = 1000;
Timer['animateBatteryTrigger'] = 6000;
Timer['checkForUpdate'] = 60000;
Timer['generateUpdateDrives'] = 5000;
Timer['updateCPU'] = 30;
Timer['updateRAM'] = 30;
Timer['updateSignal'] = 30;
Timer['updateBattery'] = 30;
Timer['updateIPinternal'] = 30;
Timer['updateIPexternal'] = 30;
Timer['abortIPexternal'] = 30000;
Timer['hideIPglobe'] = 3000;
Timer['processCheckForUpdate'] = 100;
Timer['updateDrives'] = 30;
Timer['animateSignal'] = 50;
Timer['animateBattery'] = 50;
Timer['updateIPglobe'] = 30;

cpuPercentage = new Array;
cpuPercentageTarget = new Array;
container = new Array;
ipaddressData = new Array;
ipaddressLastValidIP = new Array;
ipaddressTarget = new Array;
ipaddressDoSwitch = new Array;
ipaddressSwitchShift = new Array;
ipaddressActiveBox = new Array;
ipaddressData['ipinternal'] = 'Loading Data';
ipaddressTarget['ipinternal'] = 'Loading Data';
ipaddressLastValidIP['ipinternal'] = '0.0.0.0';
ipaddressData['ipexternal'] = 'Loading Data';
ipaddressTarget['ipexternal'] = 'Loading Data';
ipaddressLastValidIP['ipexternal'] = '0.0.0.0';
loadingStageShift = new Array;
batteryPercentRecords = new Array;

XHRlastAttemptUnixTime = 0;
XHRsucessUnixTime = 0;
XHRisBusy = false;
XHRforceRetry = false;
CheckUpdateLastAttemptUnixTime = 0;
topposition = 0;
shiftSignalSlideAni = 0;
shiftBatterySlideAni = 0;
animateSignalBusy = false;
updateSignalBusy = false;
updateBatteryBusy = false;
animateBatteryBusy = false;
signalData = 0;
signalGraph = 0;
batteryData = 0;
batteryTitle = '';
batteryUseType = -1;
batteryGraph = 0;
networkname = '';
signalDoSwitch = false;
batteryDoSwitch = false;
RamFree = totalRAM;
RamFreeTarget = totalRAM;
sliderheight = 10;
sliderwidth = 102;
animateBatterySwitchCharge = null;
animateBatterySwitchDrain = null;
batteryEstimatedRemainingSeconds = -1;
batteryPercentRemaining = 0;
IPglobeShift = 12;
IPglobeShiftTarget = 12;
IPglobeBusy = false;
percentBefore3 = -1;
percentBefore2 = -1;
percentBefore1 = -1;
percentCurrent = -1;
updateTitle = '';
updateAppVersion = gadgetVersion;
updateAppURL = '';
updateAvailable = false;

try {System.Gadget.settingsUI = "settings.html";} catch(e) {}
try {System.Gadget.onSettingsClosed = GadgetLoad;} catch(e) {}
try {System.Gadget.onShowSettings = clearAllTimeouts;} catch(e) {}

function myCollectGarbage() {
if (typeof(CollectGarbage) == "function")
    CollectGarbage();
}

function GadgetReload(){
try{$('update_text').onclick=null;} catch(e){}
myCollectGarbage();
window.location.reload();
}

function GadgetReload2(){
saveToGadget('ram',RamFreeTarget);
saveToGadget('networkname',networkname);
saveToGadget('signal',signalDataTarget);
saveToGadget('ipinternal',ipaddressTarget['ipinternal']);
saveToGadget('ipexternal',ipaddressTarget['ipexternal']);
saveToGadget('batteryPercentRemaining',batteryPercentRemaining);
saveToGadget('batteryTitle',batteryTitle);
saveToGadget('batteryUseType',batteryUseType);
saveToGadget('updateAppVersion',updateAppVersion);
saveToGadget('updateAppURL',updateAppURL);
saveToGadget('updateTitle',updateTitle);
saveToGadget('updateLastCheck',CheckUpdateLastAttemptUnixTime);
saveToGadget('urlToCheckIP',urlToCheckIP);
saveToGadget('reload','1');
try{$('update_text').onclick=null;} catch(e){}
window.location.reload();
}

function GadgetLoad(){
skinColor = 				setFromGadget('System.Gadget.Settings.read("customColorNormal")',skinColor);
skinFadeColor = 			setFromGadget('System.Gadget.Settings.read("customColorFade")',skinFadeColor);
accelerationOfAnimation = 	parseInt(setFromGadget('System.Gadget.Settings.read("acceleration")',defAcceleration));//0-9
urlToCheckIPprimary = 		removeNL(setFromGadget('System.Gadget.Settings.read("serverExIP")',defUrlToCheckIPprimary));
urlToCheckIPsecondary = 	removeNL(setFromGadget('System.Gadget.Settings.read("serverExIPsecondary")',defUrlToCheckIPsecondary));
toggleIPcheckSource();//set proper source
updateExIPinterval = 		setFromGadget('System.Gadget.Settings.read("refreshExIP")',defUpdateExIP);
updateAppVersion =  		parseFloat(setFromGadget('System.Gadget.Settings.read("updateAppVersion")',updateAppVersion));
updateTitle = 				removeNL(setFromGadget('System.Gadget.Settings.read("updateTitle")',updateTitle));
updateAppURL = 				removeNL(setFromGadget('System.Gadget.Settings.read("updateAppURL")',updateAppURL));
CheckUpdateLastAttemptUnixTime = parseInt(setFromGadget('System.Gadget.Settings.read("updateLastCheck")',CheckUpdateLastAttemptUnixTime));
exceptDrives = 				removeNL(setFromGadget('System.Gadget.Settings.read("exceptDrives")',exceptDrives)).toUpperCase();

enable['animation'] = 		(setFromGadget('System.Gadget.Settings.read("animation")',true)=='false'?false:true);
enable['showCPU'] = 		(setFromGadget('System.Gadget.Settings.read("showCPU")',true)=='false'?false:true);
enable['showRAM'] = 		(setFromGadget('System.Gadget.Settings.read("showRAM")',true)=='false'?false:true);
enable['showSignal'] = 	(setFromGadget('System.Gadget.Settings.read("showSignal")',true)=='false'?false:true);
enable['showIPinternal'] =	(setFromGadget('System.Gadget.Settings.read("showIPinternal")',true)=='false'?false:true);
enable['showIPexternal'] = (setFromGadget('System.Gadget.Settings.read("enableExIP")',true)=='false'?false:true);
enable['showBattery'] = 	(setFromGadget('System.Gadget.Settings.read("showBattery")',true)=='false'?false:true);
enable['addSeed'] = 		(setFromGadget('System.Gadget.Settings.read("addSeed")',true)=='false'?false:true);
enable['fade'] = 			(setFromGadget('System.Gadget.Settings.read("fade")',true)=='false'?false:true);
enable['update'] =  		(setFromGadget('System.Gadget.Settings.read("update")',true)=='false'?false:true);
enable['showDrives'] =  	(setFromGadget('System.Gadget.Settings.read("showDrives")',true)=='false'?false:true);
enable['CPUperUnit'] = 		(setFromGadget('System.Gadget.Settings.read("CPUperUnit")','false')=='false'?false:true);

Timer['generateUpdateSignal'] =	setFromGadget('System.Gadget.Settings.read("timer_signal")',Timer['generateUpdateSignal']);
Timer['generateUpdateIPinternal'] =	setFromGadget('System.Gadget.Settings.read("timer_ipinternal")',Timer['generateUpdateIPinternal']);
Timer['generateUpdateCPU'] =	setFromGadget('System.Gadget.Settings.read("timer_CPU")',Timer['generateUpdateCPU']);
Timer['generateUpdateRAM'] =	setFromGadget('System.Gadget.Settings.read("timer_RAM")',Timer['generateUpdateRAM']);
Timer['generateUpdateBattery'] =	setFromGadget('System.Gadget.Settings.read("timer_battery")',Timer['generateUpdateBattery']);
Timer['generateUpdateDrives'] =		setFromGadget('System.Gadget.Settings.read("timer_drives")',Timer['generateUpdateDrives']);


//update list of drives we need to check - exclude exceptions
for(var i=0; i<exceptDrives.length; i++) {
	driveLetters = driveLetters.replace(exceptDrives.charAt(i),'');
}
delete i;

if((setFromGadget('System.Gadget.Settings.read("reload")','0')=='1'?true:false)) {
	//Execute below in case of self reload to transfer data from previous session for smooth experience
	networkname = removeNL(setFromGadget('System.Gadget.Settings.read("networkname")',networkname));
	
	signalData = parseInt(setFromGadget('System.Gadget.Settings.read("signal")',signalData));
	signalGraph = getSignalGraph(signalData);
	
	RamFree = parseInt(setFromGadget('System.Gadget.Settings.read("ram")',RamFree));
	RamFreeTarget = RamFree;

	batteryPercentRemaining = parseInt(setFromGadget('System.Gadget.Settings.read("batteryPercentRemaining")',batteryPercentRemaining));
	batteryData = batteryPercentRemaining;
	batteryGraph = getBatteryGraph(batteryPercentRemaining);
	batteryTitle = removeNL(setFromGadget('System.Gadget.Settings.read("batteryTitle")',batteryTitle));
	batteryUseType = parseInt(setFromGadget('System.Gadget.Settings.read("batteryUseType")',batteryUseType));
		
	ipaddressData['ipinternal'] = removeNL(setFromGadget('System.Gadget.Settings.read("ipinternal")',ipaddressData['ipinternal']));
	ipaddressData['ipexternal'] = removeNL(setFromGadget('System.Gadget.Settings.read("ipexternal")',ipaddressData['ipexternal']));
	ipaddressTarget['ipinternal'] = ipaddressData['ipinternal'];
	ipaddressTarget['ipexternal'] = ipaddressData['ipexternal'];
	
	urlToCheckIP = removeNL(setFromGadget('System.Gadget.Settings.read("urlToCheckIP")',urlToCheckIP));
	
	for(var i=0; i<driveLetters.length; i++){
		try {
			drivesData[driveLetters.charAt(i)]['isReady'] 		= System.Shell.drive(driveLetters.charAt(i)).isReady;
			drivesData[driveLetters.charAt(i)]['totalSize'] 	= System.Shell.drive(driveLetters.charAt(i)).totalSize;
			drivesData[driveLetters.charAt(i)]['freeSpace'] 	= System.Shell.drive(driveLetters.charAt(i)).freeSpace;
			drivesData[driveLetters.charAt(i)]['volumeLabel'] 	= System.Shell.drive(driveLetters.charAt(i)).volumeLabel;
			drivesTarget[driveLetters.charAt(i)]['isReady'] 	= System.Shell.drive(driveLetters.charAt(i)).isReady;
			drivesTarget[driveLetters.charAt(i)]['totalSize'] 	= System.Shell.drive(driveLetters.charAt(i)).totalSize;
			drivesTarget[driveLetters.charAt(i)]['freeSpace'] 	= System.Shell.drive(driveLetters.charAt(i)).freeSpace;
			drivesTarget[driveLetters.charAt(i)]['volumeLabel']	= System.Shell.drive(driveLetters.charAt(i)).volumeLabel;
		} catch(e) {
			drivesData[driveLetters.charAt(i)]['isReady'] = false;
			drivesTarget[driveLetters.charAt(i)]['isReady'] = false;
		}
	}
}

saveToGadget('reload','0');
if (!isGadget) urlToCheckIP = 'http://pavel.kuzub.com/ip/?random';

containerUpdate();
setInterval(myCollectGarbage,Timer['myCollectGarbage']);
setInterval(GadgetReload2,Timer['GadgetReload']);//1800000 = 30 minutes
}


function randOrd(){
return (Math.round(Math.random())-0.5); 
}

function $(element) {
return document.getElementById(element);
}

function clearAllTimeouts(){
  for(key in IntervalTimeouts){ 
	try {clearInterval(IntervalTimeouts[key]);
	delete IntervalTimeouts[key];} catch(e) {};
  }
  for(key in TimeoutTimeouts){ 
	try {clearTimeout(TimeoutTimeouts[key]);
	delete TimeoutTimeouts[key];} catch(e) {};
  }
}

function myClearInterval(anchor){
	try {clearInterval(IntervalTimeouts[anchor]);
	delete IntervalTimeouts[anchor];} catch(e) { }
}

function mySetInterval(anchor,code,timer){
myClearInterval(anchor);
if (!IntervalTimeouts[anchor]){
	IntervalTimeouts[anchor] = setInterval(code,timer);
	}
}

function myClearTimeout(anchor){
	try {clearTimeout(TimeoutTimeouts[anchor]);
	delete TimeoutTimeouts[anchor];} catch(e) { }
}

function mySetTimeout(anchor,code,timer){
myClearTimeout(anchor);
if (!TimeoutTimeouts[anchor]){
	TimeoutTimeouts[anchor] = setTimeout(code,timer);
	}
}

function getUnixTime() {
return Math.round(new Date().getTime() / 1000);
}

function getUnixTimeMsec() {
return new Date().getTime();
}

function getUrlParameterSymbol(uri) {
return (uri.indexOf('?') != -1 ? '&' : '?');
}

function mergeIPaddrees(ip1, ip2, ip3, ip4){
return ip1+'.'+ip2+'.'+ip3+'.'+ip4;
}

function toggleSetting(setting) {
enable[setting] = (enable[setting] ? false : true);
}

function toggleRandomOrder(){
functionRunOrder.sort( randOrd );
}

function toggleIPcheckSource(){
if (urlToCheckIP == urlToCheckIPprimary) {
	urlToCheckIP = urlToCheckIPsecondary;
 } else {
	urlToCheckIP = urlToCheckIPprimary;
 }
}

function toggleAcceleration(backwards) {
if (accelerationOfAnimation >= 9 & (!backwards)) return;
if (accelerationOfAnimation <= 0 & (backwards)) return;
if (backwards) {
	accelerationOfAnimation -= 1;
 } else {
	accelerationOfAnimation += 1;
 }
}

function getFreeRam(free) {
	var suffix = 0;
	while(free > 999) {
		free = free / 1024;
		suffix++;
	}
	if(suffix != 0)
		free = free.toFixed(2);
		
	free += suffixes[suffix];
	delete suffix;
	return free;
}

function getSignalGraph(signal) {
	var graph = Math.ceil(signal/20);
	if(graph < 0) graph = 0;
	if(graph > 5) graph = 5;
	return graph;
}

function setSignalGraph(signal){
$('signal_graph_'+signalGraph).style.display = 'none';
signalGraph = Math.ceil(signal/20);
if(signalGraph < 0) signalGraph = 0;
if(signalGraph > 5) signalGraph = 5;
$('signal_graph_'+signalGraph).style.display = 'block';
}

function getBatteryGraph(battery) {
	var graph = Math.floor(battery/10);
	if(graph < 0)  graph = 0;
	if(graph > 10) graph = 10;
	return graph;
}

function setBatteryGraph(battery) {
try {$('battery_graph_'+batteryGraph).style.display = 'none';} catch(e) {}
batteryGraph = Math.floor(battery/10);
if(batteryGraph < 0)  batteryGraph = 0;
if(batteryGraph > 10) batteryGraph = 10;
try {$('battery_graph_'+batteryGraph).style.display = 'block';} catch(e) {}
}

function fitRange(number) {
	if(number < 0)	 return 0;
	if(number > 100) return 100;
	return number;
}

function validateIPaddrees(ip) {
return validateIPregExp.test(ip);
}

function getIPaddressFromText(text) {
return detectIPregExp.exec(text)[0];
}

function convertSecondsToTime(data) {
	if(data<0) return 'Draining';
	var days = parseInt(data/86400);
	data = data-(days*86400);
	var hours = parseInt(data/3600);
	data = data-(hours*3600);
	var minutes = parseInt(data/60);
	data = data-(minutes*60);
	
	if(minutes<10) minutes='0'+minutes;
	if(data<10) data='0'+data;
return hours+':'+minutes+':'+data;
}

function estimateBatteryRemainingSeconds(current, previous) {
	try {
		return Math.round((parseInt(batteryPercentRecords[current] - batteryPercentRecords[previous])/parseInt(previous - current))*current);
	} catch(e) {
		return -1;
	}
}

function getNextPos(currentPos, targetPos) {
	if (!enable['animation']) return targetPos;
	if (currentPos == targetPos) return targetPos;
	if (currentPos < targetPos) return currentPos+Math.ceil(Math.abs((((currentPos+targetPos)/2)-currentPos)*parseFloat('0.'+accelerationOfAnimation+'1')));
	if (currentPos > targetPos) return currentPos-Math.ceil(Math.abs((((currentPos+targetPos)/2)-currentPos)*parseFloat('0.'+accelerationOfAnimation+'1')));
}

function round5(x)
{
    return (x % 5) >= 2.5 ? parseInt(x / 5) * 5 + 5 : parseInt(x / 5) * 5;
}

//
// Startup and Reload All
//

function containerUpdate() {
clearAllTimeouts();
animateSignalBusy = false;
animateBatteryBusy = false;
updateSignalBusy = false;
updateBatteryBusy = false;
IPglobeBusy = false;
XHRisBusy = false;
containerTotalHeight = 0;
containerTotalHTML = '';
topposition = 0;
for (i in functionRunOrder) {
	window[functionRunOrder[i]]();
}


for (i in container) {
	if(container[i]['enable']) {
		containerTotalHeight += container[i]['height'];
		container[i]['height'] = null;
		containerTotalHTML += container[i]['html'];
		container[i]['html'] = null;
	}
}
gadgetHeight = round5(parseInt(containerTotalHeight + 25));
if(gadgetHeight < 35) {gadgetHeight = 35;} 
var bodyObj = $('body');
bodyObj.style.height		= gadgetHeight+'px';
bodyObj.style.backgroundImage	= BGblank; // IE9 transparancy fix
bodyObj.style.backgroundImage	= 'url(background/'+gadgetHeight+'.png)';
delete bodyObj;
var containerObj = $('container');
containerObj.style.height	= containerTotalHeight+'px';
containerObj.innerHTML	= containerTotalHTML;
delete containerObj
containerTotalHeight = null;
containerTotalHTML = null;
}





//
//	Part Setup - Builds nesessary fields
//
function setUpCPU() {
container['setUpCPU'] = null;
container['setUpCPU'] =  new Array();
	if(!enable['showCPU']){
		container['setUpCPU']['enable'] = false;
		return true;
	}
container['setUpCPU']['enable'] = true;
container['setUpCPU']['html'] = '';
container['setUpCPU']['height'] = (topposition == 0 || totalCPU < 1 ? 0 : 4);
	for (var i = 1; i <= totalCPU; i++){
		cpuPercentage[i] = (cpuPercentage[i] || 0);
		container['setUpCPU']['html'] += '<div class="slider_container" style="top:' + parseInt(topposition + container['setUpCPU']['height']) +'px">' +
				'<div id="cpu_' + i + '" class="slider_overlap" style="background-position:'+ Math.round((topposition + container['setUpCPU']['height'])*0.5) +'px -8px; width:' + sliderwidth + 'px"></div>' +
				'<div id="cpu_' + i + '_slide" class="slider_slide" style="background-color:' + skinColor + '; width:' + Math.round((parseFloat(sliderwidth)/100)*cpuPercentage[i]) +'px; filter:progid:DXImageTransform.Microsoft.gradient(enabled=' + enable['fade'] + ', GradientType=1, startColorstr=#00000000, endColorstr=#ff' + skinFadeColor.replace('#','') + ');"></div>' +
				'<div id="cpu_' + i + '_title" class="slider_title">CPU ' + (enable['CPUperUnit']?(totalCPU > 1 ? i : ''):'') + '</div>' +
				'<input id="cpu_' + i + '_text" class="slider_text" value="' + cpuPercentage[i] + '%" readonly="readonly" />' +
				'</div>';
		container['setUpCPU']['height'] += sliderheight;
	if(!enable['CPUperUnit']) break;
	}
delete i;
topposition += container['setUpCPU']['height'];
generateUpdateCPU();
mySetInterval('UpdateCPU',generateUpdateCPU,Timer['generateUpdateCPU']);
}

function setUpRAM() {
container['setUpRAM'] = null;
container['setUpRAM'] =  new Array();
	if(!enable['showRAM']){
		container['setUpRAM']['enable'] = false;
		return true;
	}

container['setUpRAM']['enable'] = true;
container['setUpRAM']['height'] = (topposition == 0 ? 0 : 4);
container['setUpRAM']['html'] = '<div class="slider_container" style="top:' + parseInt(topposition + container['setUpRAM']['height']) +'px">' +
		'<div id="ram" class="slider_overlap" style="background-position:'+ Math.round((topposition + container['setUpRAM']['height'])*0.5) +'px -8px; width:' + sliderwidth + 'px"></div>' +
		'<div id="ram_slide" class="slider_slide" style="background-color:' + skinColor + '; width:' + Math.round(((sliderwidth)/100) * (((totalRAM - RamFree)/totalRAM)*100)) +'px; filter:progid:DXImageTransform.Microsoft.gradient(enabled=' + enable['fade'] + ', GradientType=1, startColorstr=#00000000, endColorstr=#ff' + skinFadeColor.replace('#','') + ');"></div>' +
		'<div id="ram_title" class="slider_title">RAM</div>' +
		'<input id="ram_text" class="slider_text" value="' + getFreeRam(RamFree) + '" readonly="readonly" />' +
		'</div>';
container['setUpRAM']['height'] += sliderheight;
topposition += container['setUpRAM']['height'];
generateUpdateRAM();
mySetInterval('UpdateRAM',generateUpdateRAM,Timer['generateUpdateRAM']);
}

function setUpIPinternal() {
container['setUpIPinternal'] = null;
container['setUpIPinternal'] =  new Array();
	if(!enable['showIPinternal']){
		container['setUpIPinternal']['enable'] = false;
		return true;
	}

ipaddressActiveBox['ipinternal'] = 1;

container['setUpIPinternal']['enable'] = true;
container['setUpIPinternal']['height'] = (topposition == 0 ? 0 : 4);
container['setUpIPinternal']['html'] = '<div class="unit_ip_container" style="top:' + parseInt(topposition + container['setUpIPinternal']['height'] - 2) + 'px">' +
'<input id="ipinternal1" class="unit_ip_item" style="top:-2px; z-index:5" value="' + ipaddressData['ipinternal'] + '" readonly="readonly" />' + 
'<input id="ipinternal2" class="unit_ip_item" style="top:-14px; z-index:3" value="" readonly="readonly" />' + 
'</div>';
container['setUpIPinternal']['height'] += 8;
topposition += container['setUpIPinternal']['height'];
setTimeout(generateUpdateIPinternal,500);
mySetInterval('UpdateIPinternal',generateUpdateIPinternal,Timer['generateUpdateIPinternal']);
}

function setUpIPexternal() {
container['setUpIPexternal'] = null;
container['setUpIPexternal'] =  new Array();
	if(!enable['showIPexternal']){
		container['setUpIPexternal']['enable'] = false;
		return true;
	}

ipaddressActiveBox['ipexternal'] = 1;

container['setUpIPexternal']['enable'] = true;
container['setUpIPexternal']['height'] = (topposition == 0 ? 0 : 4);
container['setUpIPexternal']['html'] = '<div class="unit_ip_container" style="top:' + parseInt(topposition + container['setUpIPexternal']['height'] - 2) + 'px">' + 
'<input id="ipexternal1" class="unit_ip_item" style="top:-2px; z-index:5" value="' + ipaddressData['ipexternal'] + '" readonly="readonly" />' + 
'<input id="ipexternal2" class="unit_ip_item" style="top:-14px; z-index:3" value="" readonly="readonly" />' + 

'</div><div class="loading_globe_container" style="top:' + parseInt(topposition + container['setUpIPexternal']['height'] - 3) + 'px"><div id="IPglobe" class="loading_globe" style="left:' + IPglobeShift + 'px"></div></div>';

container['setUpIPexternal']['height'] += 8;
topposition += container['setUpIPexternal']['height'];

if (window.ActiveXObject) {
	for (var i = xmlHttpObjects.length -1; i >= 0; i--) {
	  try {
		httpRequest = new ActiveXObject(xmlHttpObjects[i]);
		if (httpRequest) {break;}
	  } catch(e) {}
	}
	delete i;
 } else if (typeof XMLHttpRequest != 'undefined') {
	httpRequest = new XMLHttpRequest();
	if (httpRequest.overrideMimeType){
		httpRequest.overrideMimeType('text/xml');
	}
 }
setTimeout(hideIPglobe,100);//prevent globe being stuck after containerUpdate()
setTimeout(generateUpdateIPexternal,500);
mySetInterval('UpdateIPexternal',generateUpdateIPexternal,Timer['generateUpdateIPexternal']);
}


function setUpSignal() {
container['setUpSignal'] = null;
container['setUpSignal'] = new Array();

	if(!enable['showSignal']){
		container['setUpSignal']['enable'] = false;
		return true;
	}

signalActiveBox = 1;
container['setUpSignal']['height'] = (topposition == 0 ? 0 : 4);
container['setUpSignal']['enable'] = true;
container['setUpSignal']['html'] = '<div class="unit_container" style="top:' + parseInt(topposition + container['setUpSignal']['height']) + 'px">' +
				'<input id="networkname1" class="unit_title" style="top:-2px; z-index:5" value="' + networkname + '" readonly="readonly" />' + 
				'<input id="networkname2" class="unit_title" style="top:-14px; z-index:3" value="" readonly="readonly" />' + 
				'<input id="signal_percentage" class="unit_percentage" style="top:-2px; z-index:4" value="' + signalData + '%" readonly="readonly" />' + 
				'</div>' +
				'<div class="signal_background_left"	style="top:' + parseInt(topposition + container['setUpSignal']['height'] + 14) + 'px;background-color:' + skinColor + ';filter:progid:DXImageTransform.Microsoft.gradient(enabled=' + enable['fade'] + ', GradientType=1, startColorstr=#ff' + skinFadeColor.replace('#','') + ', endColorstr=#00000000);"></div>' +
				'<div class="signal_background_right"	style="top:' + parseInt(topposition + container['setUpSignal']['height'] + 14) + 'px;background-color:' + skinColor + ';filter:progid:DXImageTransform.Microsoft.gradient(enabled=' + enable['fade'] + ', GradientType=1, startColorstr=#00000000, endColorstr=#ff' + skinFadeColor.replace('#','') + ');"></div>' +
				'<div class="signal_graph_container" style="position:absolute;top:' + parseInt(topposition + container['setUpSignal']['height'] + 14) + 'px;">' +
				'<img id="signal_graph_0" src="./images/wireless_0.png" style="display:'+(signalGraph==0?'block':'none')+'"/>' +
				'<img id="signal_graph_1" src="./images/wireless_1.png" style="display:'+(signalGraph==1?'block':'none')+'" />' +
				'<img id="signal_graph_2" src="./images/wireless_2.png" style="display:'+(signalGraph==2?'block':'none')+'" />' +
				'<img id="signal_graph_3" src="./images/wireless_3.png" style="display:'+(signalGraph==3?'block':'none')+'" />' +
				'<img id="signal_graph_4" src="./images/wireless_4.png" style="display:'+(signalGraph==4?'block':'none')+'" />' +
				'<img id="signal_graph_5" src="./images/wireless_5.png" style="display:'+(signalGraph==5?'block':'none')+'" />' +
				'</div>';

if(enable['animation']){
	container['setUpSignal']['html'] += '<div id="signal_animation_right_container" style="top:' + parseInt(topposition + container['setUpSignal']['height'] + 12) + 'px;"><div id="signal_animation_right"></div></div>' +
		'<div id="signal_animation_left_container" style="top:' + parseInt(topposition + container['setUpSignal']['height'] + 12) + 'px;"><div id="signal_animation_left"></div></div>';
}
				
container['setUpSignal']['height'] += 36;
topposition += container['setUpSignal']['height'];
setTimeout(generateUpdateSignal,500);
mySetInterval('UpdateSignal',generateUpdateSignal,Timer['generateUpdateSignal']);
if(enable['animation']) mySetInterval('animateSignalTrigger',animateSignalTrigger,Timer['animateSignalTrigger']);
}

function setUpBattery() {
container['setUpBattery'] = null;
container['setUpBattery'] = new Array();
	if(!enable['showBattery']){
		container['setUpBattery']['enable'] = false;
		return true;
	}

batteryActiveBox = 1;
batteryPercentRemaining = fitRange(setFromGadget('System.Machine.PowerStatus.batteryPercentRemaining', -20 + Math.floor(Math.random()*201)));

container['setUpBattery']['enable'] = true;
container['setUpBattery']['height'] = (topposition == 0 ? 0 : 4);
container['setUpBattery']['html'] = '<div class="unit_container" style="top:' + parseInt(topposition + container['setUpBattery']['height']) + 'px">' +
				'<input id="battery_status1" class="unit_title" style="top:-2px; z-index:5" value="' + batteryTitle + '" readonly="readonly" />' + 
				'<input id="battery_status2" class="unit_title" style="top:-14px; z-index:3" value="" readonly="readonly" />' + 
				'<input id="battery_percentage" class="unit_percentage" style="top:-2px; z-index:4" value="' + (batteryData || batteryPercentRemaining) + '%" readonly="readonly" />' + 
				'</div>' +
				'<div class="battery_background"	style="top:' + parseInt(topposition + container['setUpBattery']['height'] + 14) + 'px;background-color:' + skinColor + ';filter:progid:DXImageTransform.Microsoft.gradient(enabled=' + enable['fade'] + ', GradientType=1, startColorstr=#00000000, endColorstr=#ff' + skinFadeColor.replace('#','') + ');"></div>' +
				'<div class="battery_graph_container" style="position:absolute;top:' + parseInt(topposition + container['setUpBattery']['height'] + 14) + 'px;">' +
				'<img id="battery_graph_0" src="./images/battery_0.png" style="display:'+(batteryGraph==0?'block':'none')+'"/>' +
				'<img id="battery_graph_1" src="./images/battery_1.png" style="display:'+(batteryGraph==1?'block':'none')+'"/>' +
				'<img id="battery_graph_2" src="./images/battery_2.png" style="display:'+(batteryGraph==2?'block':'none')+'"/>' +
				'<img id="battery_graph_3" src="./images/battery_3.png" style="display:'+(batteryGraph==3?'block':'none')+'"/>' +
				'<img id="battery_graph_4" src="./images/battery_4.png" style="display:'+(batteryGraph==4?'block':'none')+'"/>' +
				'<img id="battery_graph_5" src="./images/battery_5.png" style="display:'+(batteryGraph==5?'block':'none')+'"/>' +
				'<img id="battery_graph_6" src="./images/battery_6.png" style="display:'+(batteryGraph==6?'block':'none')+'"/>' +
				'<img id="battery_graph_7" src="./images/battery_7.png" style="display:'+(batteryGraph==7?'block':'none')+'"/>' +
				'<img id="battery_graph_8" src="./images/battery_8.png" style="display:'+(batteryGraph==8?'block':'none')+'"/>' +
				'<img id="battery_graph_9" src="./images/battery_9.png" style="display:'+(batteryGraph==9?'block':'none')+'"/>' +
				'<img id="battery_graph_10" src="./images/battery_10.png" style="display:'+(batteryGraph==10?'block':'none')+'"/>' +
				'</div>';

if(enable['animation']){
	container['setUpBattery']['html'] += '<div id="battery_animation_container" style="top:' + parseInt(topposition + container['setUpBattery']['height'] + 12) + 'px"><div id="battery_animation"><div id="battery_animation_charging" style="display:none"></div><div id="battery_animation_draining" style="display:none"></div></div></div>';
}

container['setUpBattery']['height'] += 36;
topposition += container['setUpBattery']['height'];
generateUpdateBattery();
mySetInterval('UpdateBattery',generateUpdateBattery,Timer['generateUpdateBattery']);
if(enable['animation']) mySetInterval('animateBatteryTrigger',animateBatteryTrigger,Timer['animateBatteryTrigger']);
}

function setUpUpdate() {
container['setUpUpdate'] = null;
container['setUpUpdate'] =  new Array();
	if(!enable['update']){
		container['setUpUpdate']['enable'] = false;
		return true;
	}

container['setUpUpdate']['enable'] = true;
if(updateAppVersion > gadgetVersion){
	updateAvailable = true;
	container['setUpUpdate']['height'] = (topposition == 0 ? 0 : 4);
	container['setUpUpdate']['html'] = '<div id="update_container" class="unit_ip_container" style="top:' + parseInt(topposition + container['setUpUpdate']['height'] - 2) + 'px"><input id="update_text" style="top:-2px; z-index:5" value="' + updateTitle + '"  onClick="getUpdateOnClick()" readonly="readonly" /></div>';

	container['setUpUpdate']['height'] += 8;
	topposition += container['setUpUpdate']['height'];
} else {
	updateAvailable = false;
	container['setUpUpdate']['html'] = '';
	container['setUpUpdate']['height'] = 0;
}



if (window.ActiveXObject) {
	for (var i = xmlHttpObjects.length -1; i >= 0; i--) {
	  try {
		updateRequest = new ActiveXObject(xmlHttpObjects[i]);
		if (updateRequest) {break;}
	  } catch(e) {}
	}
	delete i;
} else if (typeof XMLHttpRequest != 'undefined') {
	updateRequest = new XMLHttpRequest();
	if (updateRequest.overrideMimeType){
		updateRequest.overrideMimeType('text/xml');
	}
}
checkForUpdate();
mySetInterval('checkForUpdate',checkForUpdate,Timer['checkForUpdate']);
}

function setUpDrives() {
container['setUpDrives'] = null;
container['setUpDrives'] =  new Array();
	if(!enable['showDrives']){
		container['setUpDrives']['enable'] = false;
		return true;
	}
container['setUpDrives']['enable'] = true;
container['setUpDrives']['html'] = '';
container['setUpDrives']['height'] = (topposition == 0 ? 0 : 4);

	for(var i=0; i<driveLetters.length; i++){
			try {
				drivesTarget[driveLetters.charAt(i)]['isReady'] = System.Shell.drive(driveLetters.charAt(i)).isReady;
			} catch(e) {drivesTarget[driveLetters.charAt(i)]['isReady'] = false;}
				if(drivesTarget[driveLetters.charAt(i)]['isReady']) {
					try {
					drivesData[driveLetters.charAt(i)]['totalSize'] = System.Shell.drive(driveLetters.charAt(i)).totalSize;
					drivesData[driveLetters.charAt(i)]['volumeLabel'] = System.Shell.drive(driveLetters.charAt(i)).volumeLabel;
					} catch(e) {}
				 }
				if (drivesData[driveLetters.charAt(i)]['isReady'] != drivesTarget[driveLetters.charAt(i)]['isReady']) {
					drivesData[driveLetters.charAt(i)]['freeSpace'] = drivesData[driveLetters.charAt(i)]['totalSize'];
					//Set free = total to have starting point of 0% slider for animation purposes
				 }
				 
			try {
				drivesData[driveLetters.charAt(i)]['isReady'] = System.Shell.drive(driveLetters.charAt(i)).isReady;
			} catch(e) {drivesData[driveLetters.charAt(i)]['isReady'] = false;}
				
			try {
				if(drivesData[driveLetters.charAt(i)]['isReady']) {
				container['setUpDrives']['html'] += '<div class="slider_container" style="top:' + parseInt(topposition + container['setUpDrives']['height']) +'px">' +
						'<div id="drive_' + driveLetters.charAt(i) + '" class="slider_overlap" style="background-position:'+ Math.round((topposition + container['setUpDrives']['height'])*0.5) +'px -8px; width:' + sliderwidth + 'px"></div>' +
						'<div id="drive_' + driveLetters.charAt(i) + '_slide" class="slider_slide" style="background-color:' + skinColor + '; width:' + Math.round((sliderwidth/100)*Math.round(((drivesData[driveLetters.charAt(i)]['totalSize']-drivesData[driveLetters.charAt(i)]['freeSpace'])/drivesData[driveLetters.charAt(i)]['totalSize'])*100)) +'px; filter:progid:DXImageTransform.Microsoft.gradient(enabled=' + enable['fade'] + ', GradientType=1, startColorstr=#00000000, endColorstr=#ff' + skinFadeColor.replace('#','') + ');"></div>' +
						'<div id="drive_' + driveLetters.charAt(i) + '_title" class="slider_title">' + driveLetters.charAt(i) + ': '+(drivesData[driveLetters.charAt(i)]['volumeLabel']==''?'Drive':drivesData[driveLetters.charAt(i)]['volumeLabel'])+'</div>' +
						'<input id="drive_' + driveLetters.charAt(i) + '_text" class="slider_text" value="' + getFreeRam(drivesData[driveLetters.charAt(i)]['freeSpace']) + '" readonly="readonly" />' +
						'</div>';
				container['setUpDrives']['height'] += sliderheight;
				}
			} catch(e) {continue;}		
	}
delete i;

topposition += container['setUpDrives']['height'];
generateUpdateDrives();
mySetInterval('UpdateDrives',generateUpdateDrives,Timer['generateUpdateDrives']);
}



//
//	Update Generators
//
function generateUpdateCPU() {
	if(getUnixTime()-LastExecTime['generateUpdateCPU']<2) return;
	if(!enable['showCPU'])	return;
	LastExecTime['generateUpdateCPU'] = getUnixTime();

	if(enable['CPUperUnit']) {
		for (var i = 1; i <= totalCPU; i++) {
			if(isGadget){
				cpuPercentageTarget[i] = fitRange(Math.round(System.Machine.CPUs.item(i-1).usagePercentage));
			} else {
				cpuPercentageTarget[i] = fitRange(Math.floor(Math.random()*101));
			}
		}
		delete i;
	} else {
		var sumCPU = 0;
		for (var i = 1; i <= totalCPU; i++) {
			if(isGadget){
				sumCPU += fitRange(Math.round(System.Machine.CPUs.item(i-1).usagePercentage));
			} else {
				sumCPU += fitRange(Math.floor(Math.random()*101));
			}
		}
		cpuPercentageTarget[1] = fitRange(Math.round(sumCPU/totalCPU));
		delete i;
		delete sumCPU;
	}
if(!IntervalTimeouts['cpu']) mySetInterval('cpu',updateCPU,Timer['updateCPU']);
}


function generateUpdateRAM() {
	if(getUnixTime()-LastExecTime['generateUpdateRAM']<3) return;
	if(!enable['showRAM'])	return;
	LastExecTime['generateUpdateRAM'] = getUnixTime();
	RamFreeTarget = parseInt(setFromGadget('System.Machine.availableMemory', 950 + Math.floor(Math.random()*151)));
	if(!IntervalTimeouts['ram']) mySetInterval('ram',updateRAM,Timer['updateRAM']);
}

function generateUpdateSignal() {
	if(getUnixTime()-LastExecTime['generateUpdateSignal']<2) return;
	if(!enable['showSignal']) return;
	LastExecTime['generateUpdateSignal'] = getUnixTime();

	oldNetworkname = networkname;
	if(isGadget){
		networkname = removeNL(setFromGadget('System.Network.Wireless.ssid', ''));
	} else {
		networkname = removeNL(setFromGadget('System.Network.Wireless.ssid', gadgetName + ' ' + gadgetVersion));
	}
	if (networkname != oldNetworkname) {
		if (enable['animation']) {
			signalDoSwitch = true;
			signalSwitchShift = 0;
			signalActiveBox = (signalActiveBox == 1 ? 2 : 1); // Switch active box
		}

		try {
			$('networkname' + signalActiveBox).value = networkname.substring(0,13);
		} catch(e) {}
	}
signalDataTarget = parseInt(setFromGadget('System.Network.Wireless.signalStrength', -20 + Math.floor(Math.random()*141)));
if (signalDataTarget < 0)		signalDataTarget = 0;
if (signalDataTarget >= 99)		signalDataTarget = 100; // Making happy
if((!updateSignalBusy)&(!IntervalTimeouts['signal'])) mySetInterval('signal',updateSignal,Timer['updateSignal']);
}

function generateUpdateBattery() {
	if(getUnixTime()-LastExecTime['generateUpdateBattery']<1) return;
	if(!enable['showBattery']) return;
	LastExecTime['generateUpdateBattery'] = getUnixTime();

	oldBatteryPercentRemaining = batteryPercentRemaining;
	oldBatteryUseType = batteryUseType;
	batteryPercentRemaining	= fitRange(setFromGadget('System.Machine.PowerStatus.batteryPercentRemaining', parseInt(100 - (getUnixTime()+'').substr(7,2))));
	isBatteryCharging			= setFromGadget('System.Machine.PowerStatus.isBatteryCharging',		(((batteryPercentRemaining > batteryData) && (batteryPercentRemaining < 100)) ? true : false));

	
	if (isBatteryCharging){
		batteryPercentRecords = new Array;
		batteryEstimatedRemainingSeconds = -1;
		batteryTitle = 'Charging';
		batteryUseType = 2;
	} else {
		if (oldBatteryPercentRemaining < batteryPercentRemaining) {
			batteryPercentRecords = new Array;
			batteryEstimatedRemainingSeconds = -1;
		} else if (oldBatteryPercentRemaining != batteryPercentRemaining) { // Minus another percent...
			// recording data
			batteryPercentRecords[batteryPercentRemaining] = getUnixTime();

			for (i in batteryPercentRecords) {
				percentBefore3 = (percentBefore2 >= 0 ? percentBefore2 : -1);
				percentBefore2 = (percentBefore1 >= 0 ? percentBefore1 : -1);
				percentBefore1 = (percentCurrent >= 0 ? percentCurrent : -1);
				percentCurrent = i;
			}
			if (percentBefore3 >= 0) { // Estimate remaining time using 3 last percent records. Final estimation is an average of 3 estimations
				batteryEstimatedRemainingSeconds = Math.floor((estimateBatteryRemainingSeconds(percentCurrent, percentBefore3) + estimateBatteryRemainingSeconds(percentCurrent, percentBefore2) + estimateBatteryRemainingSeconds(percentCurrent, percentBefore1))/3);
			} else if (percentBefore2 >= 0) { // Start estimation as soon as we have records for 2 last percent records
				batteryEstimatedRemainingSeconds = Math.floor((estimateBatteryRemainingSeconds(percentCurrent, percentBefore2) + estimateBatteryRemainingSeconds(percentCurrent, percentBefore1))/2);
			}

			if (percentBefore2 >= 0) { // True for both above estimation cases
				batteryLastEstimateTime = batteryPercentRecords[percentCurrent];
			}
		}

		if(batteryPercentRemaining == 100){
			batteryTitle = 'Charged';
			batteryUseType = 0;
		} else {
			if (batteryEstimatedRemainingSeconds >= 0) {
				batteryEstimatedRemainingSecondsNow = batteryEstimatedRemainingSeconds - (getUnixTime() - batteryLastEstimateTime);
				batteryTitle = convertSecondsToTime(batteryEstimatedRemainingSecondsNow);
			} else {
				batteryTitle = 'Draining';
			}
			batteryUseType = 1;
		}
    }
 	if (enable['animation']) {
		if (batteryUseType != oldBatteryUseType) {
			batteryDoSwitch = true;
			batterySwitchShift = 0;
			batteryActiveBox = (batteryActiveBox==1?2:1); // Switch active box
		}
    }
if((!updateBatteryBusy)&(!IntervalTimeouts['battery'])) mySetInterval('battery',updateBattery,Timer['updateBattery']);
}

function generateUpdateIPinternal() {
	if(getUnixTime()-LastExecTime['generateUpdateIPinternal']<5) return;
	if(!enable['showIPinternal']) return;
	LastExecTime['generateUpdateIPinternal'] = getUnixTime();
	if (removeNL(setFromGadget('System.Network.Wireless.ssid','')).length != 0) { 
	// Workaround for gadget API bug, when System.Network.Wireless.address returns last IP address even when connection was lost and wireless adaptor has no IP address.
		ipaddressTarget['ipinternal'] = removeNL(setFromGadget('System.Network.Wireless.address', '192.168.' + Math.floor(Math.random()*255) + '.' + Math.ceil(Math.random()*254)));
		
		if (removeNL(ipaddressTarget['ipinternal']).length == 0) { // In case IP is not ready. Rare case due to bug in gadget API described above
			ipaddressTarget['ipinternal'] = 'Acquiring IP';
		}
	} else {
		ipaddressTarget['ipinternal'] = 'No Wireless IP';
	}

if (ipaddressData['ipinternal']!=ipaddressTarget['ipinternal']) {
	if (enable['animation'] && (!validateIPaddrees(ipaddressData['ipinternal']) || !validateIPaddrees(ipaddressTarget['ipinternal']))){
		ipaddressDoSwitch['ipinternal'] = true;
		ipaddressSwitchShift['ipinternal'] = 0;
		ipaddressActiveBox['ipinternal'] = (ipaddressActiveBox['ipinternal'] == 1 ? 2 : 1); // Switch active box
	}
 if(!IntervalTimeouts['ipinternal']) mySetInterval('ipinternal',updateIPinternal,Timer['updateIPinternal']);
 }
}




function generateUpdateIPexternal() {
	if(getUnixTime()-LastExecTime['generateUpdateIPexternal']<5) return;
	if(!enable['showIPexternal']) return;
	LastExecTime['generateUpdateIPexternal'] = getUnixTime();

	if(XHRisBusy) return;
if (parseInt(XHRlastAttemptUnixTime + 30) < getUnixTime() || XHRforceRetry) {
	if (parseInt(XHRsucessUnixTime + updateExIPinterval) < getUnixTime() || XHRforceRetry) {
	
		if(!XHRisBusy){
			showIPglobe();
			XHRforceRetry = false;
			XHRlastAttemptUnixTime = getUnixTime();
			if (httpRequest) {
				XHRisBusy = true;
				try {httpRequest.abort();} catch(e) {}
				httpRequest.open('GET',urlToCheckIP+(enable['addSeed']?getUrlParameterSymbol(urlToCheckIP)+'time='+getUnixTime():''),true);
				try {httpRequest.send(null);} catch(e) {}
				if(!IntervalTimeouts['processIPexternalData']) mySetInterval('processIPexternalData',processIPexternalData,100);// no circular reference
				if(!IntervalTimeouts['abortIPexternal']) mySetInterval('abortIPexternal',abortIPexternal,Timer['abortIPexternal']);
				} else {
				XHRisBusy = false;
			}
			delete i;
		}
	}
 }

if (ipaddressData['ipexternal']!=ipaddressTarget['ipexternal']) {
	if (enable['animation'] && (!validateIPaddrees(ipaddressData['ipexternal']) || !validateIPaddrees(ipaddressTarget['ipexternal']))){
		ipaddressDoSwitch['ipexternal'] = true;
		ipaddressSwitchShift['ipexternal'] = 0;
		ipaddressActiveBox['ipexternal'] = (ipaddressActiveBox['ipexternal'] == 1 ? 2 : 1); // Switch active box
	}
  if(!IntervalTimeouts['ipexternal']) mySetInterval('ipexternal',updateIPexternal,Timer['updateIPexternal']);
 }
}

//
//	External IP address functions
//

function processIPexternalData() {
	XHRforceRetry = false;
	if (httpRequest.readyState==4) {
	switch(httpRequest.status){
	case 200:	if (detectIPregExp.test(httpRequest.responseText)) {XHRresponse = getIPaddressFromText(httpRequest.responseText);} else {XHRresponse = 'Bad Response'; toggleIPcheckSource();} break;
	case 0:  	XHRresponse = 'Local Mode'; break;
	case 12007:	XHRresponse = 'Can\'t resolve'; toggleIPcheckSource(); XHRforceRetry = true; break;
	case 12029:	XHRresponse = 'No Internet'; toggleIPcheckSource(); XHRforceRetry = true; break;
	default:	XHRresponse = 'Error '+httpRequest.status; toggleIPcheckSource(); XHRforceRetry = true;
	}
	mySetInterval('hideIPglobe',hideIPglobe,Timer['hideIPglobe']);//Interval to ensure hiding when sleep/wake
	ipaddressTarget['ipexternal'] = XHRresponse;
	if (ipaddressData['ipexternal']!=ipaddressTarget['ipexternal']) {
		if (enable['animation'] && (!validateIPaddrees(ipaddressData['ipexternal']) || !validateIPaddrees(ipaddressTarget['ipexternal']))){
			ipaddressDoSwitch['ipexternal'] = true;
			ipaddressSwitchShift['ipexternal'] = 0;
			ipaddressActiveBox['ipexternal'] = (ipaddressActiveBox['ipexternal'] == 1 ? 2 : 1); // Switch active box
		}
	  if(!IntervalTimeouts['ipexternal']) mySetInterval('ipexternal',updateIPexternal,Timer['updateIPexternal']);
	 }
	XHRisBusy = false;
	XHRsucessUnixTime = getUnixTime();
	myClearInterval('processIPexternalData');
	myClearInterval('abortIPexternal');
	}
}

function abortIPexternal() {
try {httpRequest.abort();} catch(e) {}
XHRisBusy = false;
myClearInterval('processIPexternalData');
myClearInterval('abortIPexternal');
ipaddressTarget['ipexternal'] = 'Timeout';
toggleIPcheckSource();
	if (ipaddressData['ipexternal']!=ipaddressTarget['ipexternal']) {
		if (enable['animation'] && (!validateIPaddrees(ipaddressData['ipexternal']) || !validateIPaddrees(ipaddressTarget['ipexternal']))){
			ipaddressDoSwitch['ipexternal'] = true;
			ipaddressSwitchShift['ipexternal'] = 0;
			ipaddressActiveBox['ipexternal'] = (ipaddressActiveBox['ipexternal'] == 1 ? 2 : 1); // Switch active box
		}
	}
if(!IntervalTimeouts['ipexternal']) mySetInterval('ipexternal',updateIPexternal,Timer['updateIPexternal']);
}


function checkForUpdate() {
	if(!enable['update']) return;
	if(getUnixTime()-CheckUpdateLastAttemptUnixTime<86400) return;

	if (updateRequest) {
		try {updateRequest.abort();} catch(e) {}
		updateRequest.open('GET',urlToCheckUpdate+(enable['addSeed']?getUrlParameterSymbol(urlToCheckUpdate)+'time='+getUnixTime():''),true);
		try {updateRequest.send(null);} catch(e) {}
		if(!IntervalTimeouts['processCheckForUpdate']) mySetInterval('processCheckForUpdate',processCheckForUpdate,Timer['processCheckForUpdate']);
		}

}



function processCheckForUpdate() {
	if (updateRequest.readyState==4) {
		if (updateRequest.status==200) {
			if(updateRequest.responseXML.getElementsByTagName(gadgetShortName)[0]){
				updateAppVersion = parseFloat(updateRequest.responseXML.getElementsByTagName(gadgetShortName)[0].getElementsByTagName('version')[0].childNodes[0].nodeValue);
				updateAppURL = removeNL(updateRequest.responseXML.getElementsByTagName(gadgetShortName)[0].getElementsByTagName('updateurl')[0].childNodes[0].nodeValue);
				updateTitle =  removeNL(updateRequest.responseXML.getElementsByTagName(gadgetShortName)[0].getElementsByTagName('title')[0].childNodes[0].nodeValue);
				CheckUpdateLastAttemptUnixTime = getUnixTime();
				saveToGadget('updateAppVersion',updateAppVersion);
				saveToGadget('updateAppURL',updateAppURL);
				saveToGadget('updateTitle',updateTitle);
				saveToGadget('updateLastCheck',CheckUpdateLastAttemptUnixTime);

				if(updateAppVersion > gadgetVersion){
					if (updateAvailable){
						$('update_text').value = updateTitle;
						$('update_text').onclick=getUpdateOnClick;
					} else {
						containerUpdate();
					}
				}
			}
			myClearInterval('processCheckForUpdate');
		}
	}
}

function getUpdateOnClick() {
setTimeout(getUpdate,100);
return true;
}

function getUpdate() {
window.open(updateAppURL);
}


function generateUpdateDrives() {
//	if(getUnixTime()-LastExecTime['generateUpdateDrives']<5) return;
	if(!enable['showDrives'])	return;
	LastExecTime['generateUpdateDrives'] = getUnixTime();
	//below is getting drive data
	for(var i=0; i<driveLetters.length; i++){
		try {
			drivesTarget[driveLetters.charAt(i)]['isReady'] = System.Shell.drive(driveLetters.charAt(i)).isReady;
			if(drivesTarget[driveLetters.charAt(i)]['isReady']) {
				drivesTarget[driveLetters.charAt(i)]['totalSize'] = System.Shell.drive(driveLetters.charAt(i)).totalSize;
				drivesTarget[driveLetters.charAt(i)]['freeSpace'] = System.Shell.drive(driveLetters.charAt(i)).freeSpace;
				drivesTarget[driveLetters.charAt(i)]['volumeLabel'] = System.Shell.drive(driveLetters.charAt(i)).volumeLabel;
			}
		} catch(e) {drivesTarget[driveLetters.charAt(i)]['isReady'] = false;}		
	}
	delete i;
	if(!IntervalTimeouts['drives']) mySetInterval('drives',updateDrives,Timer['updateDrives']);
}


//
//	Field Updaters
//

function updateCPU() {
if(LastEndTime['updateCPU']<LastExecTime['updateCPU']) return;
LastExecTime['updateCPU'] = getUnixTimeMsec();
var count = 0;

	for (var i = 1; i <= totalCPU; i++) {
		if(cpuPercentage[i] != cpuPercentageTarget[i]){
			cpuPercentage[i] = getNextPos(cpuPercentage[i], cpuPercentageTarget[i]);
			try {$('cpu_' + i + '_text').value = cpuPercentage[i]+'%';} catch(e){}
			try {$('cpu_' + i + '_slide').style.width	= Math.round((sliderwidth/100)*cpuPercentage[i]) + 'px';} catch(e){}
			count++;
		}
	if(!enable['CPUperUnit']) break;
	}
if (count==0) myClearInterval('cpu');
delete count;
delete i;
LastEndTime['updateCPU'] = getUnixTimeMsec();
}


function updateRAM() {
if(LastEndTime['updateRAM']<LastExecTime['updateRAM']) return;
LastExecTime['updateRAM'] = getUnixTimeMsec();
	if (RamFree==RamFreeTarget) {
		myClearInterval('ram');
		LastEndTime['updateRAM'] = getUnixTimeMsec();
		return;
	}
	RamFree = getNextPos(RamFree, RamFreeTarget);
	try {$('ram_text').value = getFreeRam(RamFree);} catch(e){}
	try {$('ram_slide').style.width	= Math.round((sliderwidth/100)*Math.round(((totalRAM-RamFree)/totalRAM)*100)) + 'px';} catch(e){}
LastEndTime['updateRAM'] = getUnixTimeMsec();
}

function updateSignal() {
	signalData = getNextPos((signalData || 0), signalDataTarget);
	setSignalGraph(signalData);
	$('signal_percentage').value = signalData + '%';

	if (signalDoSwitch) {
		$('networkname' + signalActiveBox).style.top = parseInt(signalSwitchShift - 14) + 'px';
		$('networkname' + (signalActiveBox==1?2:1)).style.top = parseInt(signalSwitchShift - 2) + 'px';
		if (signalSwitchShift >= 12) {
			signalDoSwitch = false;
			$('networkname' + (signalActiveBox==1?2:1)).value = '';
			$('networkname' + (signalActiveBox==1?2:1)).style.top = '-14px'; // Get ready for next switch
		} else {
			signalSwitchShift++;
		}
	}

	if (signalData != signalDataTarget || signalDoSwitch) {
		updateSignalBusy = true;
	} else {
		myClearInterval('signal');
		updateSignalBusy = false;
	}
}

function updateBattery() {
	batteryData = getNextPos(batteryData, batteryPercentRemaining);
	setBatteryGraph(batteryData);
	$('battery_percentage').value = batteryData + '%';
	$('battery_status' + batteryActiveBox).value = batteryTitle;
	
	if (batteryDoSwitch) {
		$('battery_status' + batteryActiveBox).style.top = parseInt(batterySwitchShift - 14) + 'px';
		$('battery_status' + (batteryActiveBox==1?2:1)).style.top = parseInt(batterySwitchShift - 2) + 'px';
		if (batterySwitchShift >= 12) {
			batteryDoSwitch = false;
			$('battery_status' + (batteryActiveBox==1?2:1)).value = ''; // Clear inactive box
			$('battery_status' + (batteryActiveBox==1?2:1)).style.top = '-14px'; // Get ready for next switch
		} else {
			batterySwitchShift++;
		}
	}

	if (batteryData != batteryPercentRemaining || batteryDoSwitch) {
		updateBatteryBusy = true;
	} else {
		myClearInterval('battery');
		updateBatteryBusy = false;
	}
}

function updateIPinternal() {
updateIP(ipaddressTarget['ipinternal'], 'ipinternal');
}

function updateIPexternal() {
updateIP(ipaddressTarget['ipexternal'], 'ipexternal');
}

function updateIP(ipaddress, ipfield, noswitch) {
	if (ipaddress != ipaddressData[ipfield] || ipaddressDoSwitch[ipfield]){} else {
		myClearInterval(ipfield);
		return;
		}
	
	if ((ipaddress == ipaddressData[ipfield]) & !ipaddressDoSwitch[ipfield]) return;
	
	if (ipaddressDoSwitch[ipfield]) {
		$(ipfield + ipaddressActiveBox[ipfield]).style.top = parseInt(ipaddressSwitchShift[ipfield] - 14) + 'px';
		$(ipfield + (ipaddressActiveBox[ipfield]==1?2:1)).style.top = parseInt(ipaddressSwitchShift[ipfield] - 2) + 'px';
		
		if (ipaddressSwitchShift[ipfield] >= 12) {
			ipaddressDoSwitch[ipfield] = false;
			$(ipfield + (ipaddressActiveBox[ipfield]==1?2:1)).value = '';
			$(ipfield + (ipaddressActiveBox[ipfield]==1?2:1)).style.top = '-14px'; // Get ready for next switch
		} else {
			ipaddressSwitchShift[ipfield]++;
		}
	}


	if (validateIPaddrees(ipaddress)) {
		if (enable['animation']) {
			var ipparts = ipaddress.split('.',4);
			var tempIPparts = ipaddressLastValidIP[ipfield].split('.',4);
			ipaddressData[ipfield] = mergeIPaddrees(
				(tempIPparts[0]==ipparts[0]?ipparts[0]:getNextPos(parseInt(tempIPparts[0]),parseInt(ipparts[0]))),
				(tempIPparts[1]==ipparts[1]?ipparts[1]:getNextPos(parseInt(tempIPparts[1]),parseInt(ipparts[1]))), 
				(tempIPparts[2]==ipparts[2]?ipparts[2]:getNextPos(parseInt(tempIPparts[2]),parseInt(ipparts[2]))), 
				(tempIPparts[3]==ipparts[3]?ipparts[3]:getNextPos(parseInt(tempIPparts[3]),parseInt(ipparts[3]))) );
			delete ipparts;
			delete tempIPparts;
		} else {
			ipaddressData[ipfield] = ipaddress;
		}
		ipaddressLastValidIP[ipfield] = ipaddressData[ipfield];
	} else {
		ipaddressData[ipfield] = ipaddress;
	}
	
$(ipfield + ipaddressActiveBox[ipfield]).value = ipaddressData[ipfield];
}

function updateDrives() {
if(LastEndTime['updateDrives']<LastExecTime['updateDrives']) return;
LastExecTime['updateDrives'] = getUnixTimeMsec();
var count = 0;
	for(var i=0; i<driveLetters.length; i++) {
		//Check if isReady state has changed - if yes, we need to redraw
		if (drivesData[driveLetters.charAt(i)]['isReady'] != drivesTarget[driveLetters.charAt(i)]['isReady']) {
			myClearInterval('drives');
			LastEndTime['updateDrives'] = getUnixTimeMsec();
			setTimeout(containerUpdate,100);
			return;
		}

		if((drivesData[driveLetters.charAt(i)]['totalSize'] != drivesTarget[driveLetters.charAt(i)]['totalSize'])||(drivesData[driveLetters.charAt(i)]['freeSpace'] != drivesTarget[driveLetters.charAt(i)]['freeSpace'])||(drivesData[driveLetters.charAt(i)]['volumeLabel'] != drivesTarget[driveLetters.charAt(i)]['volumeLabel'])){

			drivesData[driveLetters.charAt(i)]['totalSize'] = drivesTarget[driveLetters.charAt(i)]['totalSize'];
			drivesData[driveLetters.charAt(i)]['freeSpace'] = getNextPos(parseInt(drivesData[driveLetters.charAt(i)]['freeSpace']), parseInt(drivesTarget[driveLetters.charAt(i)]['freeSpace']));
			drivesData[driveLetters.charAt(i)]['volumeLabel'] = drivesTarget[driveLetters.charAt(i)]['volumeLabel'];
			try {$('drive_' + driveLetters.charAt(i) + '_title').innerText = driveLetters.charAt(i)+': '+(drivesData[driveLetters.charAt(i)]['volumeLabel']==''?'Drive':drivesData[driveLetters.charAt(i)]['volumeLabel']);} catch(e){}
			try {$('drive_' + driveLetters.charAt(i) + '_text').value = getFreeRam(drivesData[driveLetters.charAt(i)]['freeSpace']);} catch(e){}
			try {$('drive_' + driveLetters.charAt(i) + '_slide').style.width	= Math.round((sliderwidth/100)*Math.round(((drivesData[driveLetters.charAt(i)]['totalSize']-drivesData[driveLetters.charAt(i)]['freeSpace'])/drivesData[driveLetters.charAt(i)]['totalSize'])*100)) + 'px';} catch(e){}
			count++;
		}
	}
if (count==0) myClearInterval('drives');
delete count;
delete i;
LastEndTime['updateDrives'] = getUnixTimeMsec();
}

//
// Animation
//
function animateSignalTrigger() {
if(enable['animation']&(!animateSignalBusy)) mySetInterval('animateSignal',animateSignal,Timer['animateSignal']);
}

function setSignalAnimation(shift){
$('signal_animation_right').style.left = parseInt(-18+shift) + 'px';
$('signal_animation_left').style.left  = parseInt(50-shift) + 'px';
}

function animateSignal() {
	if(!enable['showSignal']) return;
	if(shiftSignalSlideAni>=68||!enable['animation']){
		myClearInterval('animateSignal');
		shiftSignalSlideAni = 0;
		animateSignalBusy = false;
		return;
	} else {
		animateSignalBusy = true;
		shiftSignalSlideAni += 2
	}
setSignalAnimation(shiftSignalSlideAni);
}

function animateBatteryTrigger() {
if(enable['animation']&(!animateBatteryBusy)&(batteryUseType!=0)) mySetInterval('animateBattery',animateBattery,Timer['animateBattery']);
}

function animateBatterySwitch(charge,drain) {

if (animateBatterySwitchCharge != charge) {
	try { $('battery_animation_charging').style.display = (charge?'block':'none'); }catch(e) {}
	animateBatterySwitchCharge = charge;
	}
if (animateBatterySwitchDrain != drain) {
	try { $('battery_animation_draining').style.display = (drain?'block':'none'); }catch(e) {}
	animateBatterySwitchDrain = drain;
	}
}

function setBatteryAnimation(shift){
$('battery_animation').style.left = parseInt(-18+shift) + 'px';
}

function animateBattery() {
	if(!enable['showBattery'] || !enable['animation']) {
		return;
	}
	if (batteryUseType == 1) {//Drain
		animateBatterySwitch(false,true);
		shiftBatterySlideAni -= 2;
		setBatteryAnimation(shiftBatterySlideAni);
	} else if (batteryUseType == 2) {//Charge
		animateBatterySwitch(true,false);
		shiftBatterySlideAni += 2;
		setBatteryAnimation(shiftBatterySlideAni);
	} else {
		myClearInterval('animateBattery');
		animateBatterySwitch(false,false);
		animateBatteryBusy = false;
		shiftBatterySlideAni = (isBatteryCharging ? 0 : 118);
		return;
	}

	if (shiftBatterySlideAni >= 118||shiftBatterySlideAni <= 0) {
		myClearInterval('animateBattery');
		animateBatteryBusy = false;
		shiftBatterySlideAni = (isBatteryCharging ? 0 : 118);
		return;
	} else {
		animateBatteryBusy = true;
	}
}

function showIPglobe(){
IPglobeShiftTarget = 0;
if(!IPglobeBusy) mySetInterval('IPglobe',updateIPglobe,Timer['updateIPglobe']);
}

function hideIPglobe(){
myClearInterval('hideIPglobe');
IPglobeShiftTarget = 12;
if(!IPglobeBusy) mySetInterval('IPglobe',updateIPglobe,Timer['updateIPglobe']);
}


function updateIPglobe() {
	if (IPglobeShift == IPglobeShiftTarget) {
		myClearInterval('IPglobe');
		IPglobeBusy = false;
		return;
	} else {
		IPglobeBusy = true;
	}

	if (enable['animation']) {
		if (IPglobeShift < IPglobeShiftTarget) {
			IPglobeShift += 1;
		} else {
			IPglobeShift -= 1;
		}
	} else {
		IPglobeShift = IPglobeShiftTarget;
	}
	try {
		$('IPglobe').style.left = IPglobeShift + 'px';
	} catch(e) { }
	
}
